
#define WINVER 0x400
#define _WIN32_WINNT 0x400

#include <windows.h>
#include <wininet.h>
#include <commctrl.h>
#include <vector>
#include <string>

#include "sqlite/sqlite.h"
#include "edapi.h"
#include "reclassify.h"

//---------------------------------------------------------------------------
#define CMD_OPENPOPFILE		 PLUGIN_CMDID_START
#define CMD_RECLASSIFY		(PLUGIN_CMDID_START + 1) /* u+8v܂ŗ\ς */


//---------------------------------------------------------------------------
extern "C" {
	DWORD EDH_OnHandleEvent(DWORD, DWORD, WPARAM, LPARAM);
	void  EDH_OnCmdProc(DWORD, DWORD, WPARAM, LPARAM);
}
//---------------------------------------------------------------------------
extern CEdAPI eda;

HWND		hWndMain = NULL;
HWND		hWndList = NULL;
HINSTANCE	hInstDll = NULL;

POPFILEINFO				pinfo;
std::vector<MAILDATA>	mdata;


//---------------------------------------------------------------------------
// RequestProp() : vpeBNGXg
//---------------------------------------------------------------------------
void RequestProp(PLUGINPROP* pprop)
{
	pprop->type = PLT_NORMAL;
	lstrcpy(pprop->name,			PLUGIN_NAME);
	lstrcpy(pprop->version,			VERSION);
	lstrcpy(pprop->versionDate,		VERSION_DATE);
	lstrcpy(pprop->authorName,		AUTHOR_NAME);
	lstrcpy(pprop->authorEmail,		AUTHOR_EMAIL);
	lstrcpy(pprop->authorUrl,		AUTHOR_URL);
	lstrcpy(pprop->comment,			COMMENT);
	lstrcpy(pprop->accountTypeName,	ACCOUNT_TYPE_NAME);
	lstrcpy(pprop->accountComment,	ACCOUNT_COMMENT);
	lstrcpy(pprop->rserved1,		RESERVED1);
	lstrcpy(pprop->rserved2,		RESERVED2);
	lstrcpy(pprop->rserved3,		RESERVED3);
}


//---------------------------------------------------------------------------
// GetIniFilePath() : ݒt@CpX̎擾
//---------------------------------------------------------------------------
void GetIniFilePath(char* path_result)
{
	char path_module[_MAX_PATH + 1];
	char drive[_MAX_DRIVE + 1];
	char   dir[_MAX_DIR   + 1];
	char fname[_MAX_FNAME + 1];
	char   ext[_MAX_EXT   + 1];
	
	if(GetModuleFileName(hInstDll, (LPSTR)path_module, sizeof(path_module)) > 0){
		_splitpath( path_module, drive, dir, fname, ext ) ;
		_makepath(  path_result, drive, dir, fname, ".ini" );
	}
}


//---------------------------------------------------------------------------
// GetBucketsCallback() : oPc擾pR[obN֐
//---------------------------------------------------------------------------
#pragma argsused
static int GetBucketsCallback(void *notused, int argc, char **argv, char **azColName)
{
	for(int i=0; i<argc; i++){
		if(argv[i] != NULL){
			lstrcpyn(pinfo.szPopfileBucket[pinfo.nBucketSize], argv[i], BUCKET_BUFFER);
			pinfo.nBucketSize++;
		}
	}
	
	return 0;
}

//---------------------------------------------------------------------------
// CheckReclassifyCallback() : XVmFpR[obN֐
//---------------------------------------------------------------------------
#pragma argsused
static int CheckReclassifyCallback(void *mdata, int argc, char **argv, char **azColName)
{
	for(int i=0; i<argc; i++){
		if(argv[i] != NULL){
			if(lstrcmp(((MAILDATA *)mdata)->bucket, argv[i]) == 0){
				((MAILDATA *)mdata)->state = 0;		// ύXׂlƓ
			} else {
				((MAILDATA *)mdata)->state = 1;
			}
		}
	}
	return 0;
}


//---------------------------------------------------------------------------
// GetClassificationCallback() : ގ擾pR[obN֐
//---------------------------------------------------------------------------
#pragma argsused
static int GetClassificationCallback(void *mdata, int argc, char **argv, char **azColName)
{
	for(int i=0; i<argc; i++){
		if(argv[i] != NULL){
			lstrcpy(((MAILDATA *)mdata)->bucket, argv[i]);
		}
	}
	return 0;
}


//---------------------------------------------------------------------------
// GetBuckets() : oPcꗗ擾
//---------------------------------------------------------------------------
int GetBuckets()
{
	sqlite	*db;
	int		result;
	char	*errmsg  = 0;
	char	sql[64] = "SELECT name FROM buckets WHERE userid=1 AND pseudo=0 LIMIT 8;";
	
	db = sqlite_open(pinfo.szPopfileDb, 0, &errmsg);
	if(db == 0){
		MessageBox(NULL, errmsg, "POPfile ", MB_OK|MB_ICONWARNING);
		sqlite_freemem(errmsg);
		return 0;
	}
	
	result = sqlite_exec(db, sql, GetBucketsCallback, 0, &errmsg);
	if(result || errmsg){
		if(errmsg){
			MessageBox(NULL, errmsg, "POPfile ", MB_OK|MB_ICONWARNING);
			sqlite_freemem(errmsg);
		} else {
			MessageBox(NULL, sql, "POPfile ", MB_OK|MB_ICONWARNING);
		}
	}
	
	sqlite_close(db);
	return 1;
}


//---------------------------------------------------------------------------
// CheckReclassify() : XVmF
//---------------------------------------------------------------------------
void CheckReclassify()
{
	sqlite	*db;
	int		result;
	char	*errmsg = 0;
	char	sql[128];
	
	db = sqlite_open(pinfo.szPopfileDb, 0, &errmsg);
	if(db == 0){
		MessageBox(NULL, errmsg, "POPfile ", MB_OK|MB_ICONWARNING);
		sqlite_freemem(errmsg);
		return;
	}
	
	for(unsigned int i=0; i<mdata.size(); i++){
		mdata[i].state = 2;
		wsprintf(sql, "SELECT name FROM history, buckets WHERE history.id=%s AND buckets.id = history.bucketid;", mdata[i].id);
		result = sqlite_exec(db, sql, CheckReclassifyCallback, &mdata[i], &errmsg);
		if(result || errmsg){
			if(errmsg){
				MessageBox(NULL, errmsg, "POPfile ", MB_OK|MB_ICONWARNING);
				sqlite_freemem(errmsg);
			} else {
				MessageBox(NULL, sql, "POPfile ", MB_OK|MB_ICONWARNING);
			}
		}
	}
	
	sqlite_close(db);
}


//---------------------------------------------------------------------------
// GetCurrentClassification() : ނ̎擾
//---------------------------------------------------------------------------
void GetCurrentClassification()
{
	sqlite	*db;
	int		result;
	char	*errmsg = 0;
	char	sql[128];
	
	db = sqlite_open(pinfo.szPopfileDb, 0, &errmsg);
	if(db == 0){
		MessageBox(NULL, errmsg, "POPfile ", MB_OK|MB_ICONWARNING);
		sqlite_freemem(errmsg);
		return;
	}
	
	wsprintf(sql, "SELECT name FROM history, buckets WHERE history.id=%s AND buckets.id = history.bucketid;", mdata[0].id);
	result = sqlite_exec(db, sql, GetClassificationCallback, &mdata[0], &errmsg);
	if(result || errmsg){
		if(errmsg){
			MessageBox(NULL, errmsg, "POPfile ", MB_OK|MB_ICONWARNING);
			sqlite_freemem(errmsg);
		} else {
			MessageBox(NULL, sql, "POPfile ", MB_OK|MB_ICONWARNING);
		}
	}
	
	sqlite_close(db);
}


//---------------------------------------------------------------------------
// GetPortNumber() : Rg[Z^[̃|[gԍ擾
//---------------------------------------------------------------------------
int GetPortNumber(const char *szConfigFilePath)
{
	int		nFileSize;
	int		nPort = 8080;
	char	*data, *p;
	
	HANDLE	hFile;
	DWORD	dwReadBytes;
	
	// popfile.cfg 擾
	hFile = CreateFile(szConfigFilePath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if(hFile != INVALID_HANDLE_VALUE){
		nFileSize = GetFileSize(hFile, NULL);
		data = (char*)malloc(nFileSize);
		if(data != NULL){
			ReadFile(hFile, data, nFileSize, &dwReadBytes, NULL);
			p = strstr(data, "html_port ");
			if(p != NULL){
				nPort = 0;
				p += 10;
				while((0x30 <= *p)&&(*p <= 0x39)){
					nPort = nPort * 10 + (*p - 0x30);
					p++;
				}
			}
			free(data);
		}
		CloseHandle(hFile);
	}
	pinfo.nPopfilePort = nPort;
	
	return nPort;
}


//---------------------------------------------------------------------------
// GetHeaderInfo() : [̃wb_擾
//---------------------------------------------------------------------------
#define NUM_OF_HEADER	3
void GetHeaderInfo(const char *mail, MAILDATA *md)
{
	int			x   = 0;
	int			len = lstrlen(mail);
	char		*mp;
	char		*field[NUM_OF_HEADER] = { 0 };
	static char	 fname[NUM_OF_HEADER][32] = { "X-POPFile-Link", "X-Text-Classification", "Subject" };
	
	
	// [wb_擾
	mp = (char *)mail;
	for(int i=0; i<(len-1); i++){
		// wb_̏Im
		if((x == 0)&&(*mp=='\r')&&(*(mp+1)=='\n')) break;
		
		// tB[h̏I[
		if(*mp == ':'){
			for(int j=0; j<NUM_OF_HEADER; j++){
				if((strnicmp( (const char*)(mp-x), fname[j], x-1) == 0) && (!field[j])){
					int xx = 0;
					while(-1){
						// s̎󔒕ȊOȂ΃[v
						if(*(mp + xx) == '\n'){
							if((*(mp + xx + 1) != 0x20)&&(*(mp + xx + 1) != 0x09)) break;
						}
						xx++;
					}
					//
					char fdata;
					int  fsize = 0;
					field[j] = (char*)malloc(xx);
					for(int k=2; k<(xx-1); k++){
						fdata = *(mp + k);
						if((fdata != '\r')&&(fdata != '\n')){
							field[j][fsize++] = fdata;
						}
					}
					field[j][fsize] = '\0';
					mp += xx;
					break;
				}
			}
		}
		
		// LF͉s
		if(*mp == '\n'){ x = 0; } else { x++; }
		mp++;
	}
	
	//
	if(field[0]){
		char *idp = strstr(field[0], "view=");	// ID̂ݒo
		if(idp != NULL) lstrcpyn(md->id, (char *)(idp+5), sizeof(md->id));
	}
	if(field[1]) lstrcpyn(md->bucket,  field[1], sizeof(md->bucket));
	if(field[2]) lstrcpyn(md->subject, field[2], sizeof(md->subject));
	
	for(int i=0; i<NUM_OF_HEADER; i++){
		if(field[i]) free(field[i]);
	}
}


//---------------------------------------------------------------------------
// GetSessionKey() : ZbVL[擾
//---------------------------------------------------------------------------
int GetSessionKey(HINTERNET hSession, char *szSessionKey)
{
	HINTERNET	hRequest;
	DWORD		dwReadSize;
	DWORD		dwBufferSize;
	char		szBufferSize[16];
	char		szPassword[256];
	char		szEntityBody[256 + 32];
	char		szIniFilePath[_MAX_PATH + 1];
	char		*szBuffer, *p;
	BOOL		bAuthentication = false;
	
	static const char szHeader[] = "Content-Type: application/x-www-form-urlencoded";
	
	// gbvy[WHTML擾
	dwReadSize = sizeof(szBufferSize);
	hRequest = HttpOpenRequest(hSession, "GET", "/", NULL, NULL, NULL, 0, 0);
	HttpSendRequest(hRequest, NULL, 0, NULL, 0);
	HttpQueryInfo(hRequest, HTTP_QUERY_CONTENT_LENGTH, szBufferSize, &dwReadSize, NULL);
	dwBufferSize = atol(szBufferSize);
	
	szBuffer = (char*)malloc(dwBufferSize);
	if(szBuffer != NULL){
		InternetReadFile(hRequest, szBuffer, dwBufferSize, &dwReadSize);
		
		p = strstr(szBuffer, "thePassword");
		if(p != NULL){
			// vF؂̏ꍇ̓pX[h𑗐MĂĎ擾
			bAuthentication = true;
			dwReadSize = sizeof(szBufferSize);
			hRequest = HttpOpenRequest(hSession, "POST", "/password", NULL, NULL, NULL, INTERNET_FLAG_EXISTING_CONNECT, 0);
			
			GetIniFilePath(szIniFilePath);
			GetPrivateProfileString("secure", "password", "", szPassword, sizeof(szPassword), szIniFilePath);
			wsprintf(szEntityBody, "redirect=%%2F&submit=%d&password=%s", sizeof(szEntityBody),  szPassword);
			HttpSendRequest(hRequest, szHeader, sizeof(szHeader), (void*)szEntityBody, lstrlen(szEntityBody));
			
			HttpQueryInfo(hRequest, HTTP_QUERY_CONTENT_LENGTH, szBufferSize, &dwReadSize, NULL);
			dwBufferSize = atol(szBufferSize);
			
			free(szBuffer);
			szBuffer = (char*)malloc(dwBufferSize);
			if(szBuffer == NULL) return 2;
			InternetReadFile(hRequest, szBuffer, dwBufferSize, &dwReadSize);
		}
		
		// ZbVL[
		p = strstr(szBuffer, "name=\"session\" value=\"");
		if(p != NULL){
			p += 22;
			for(int i=0; i<SESSION_BUFFER; i++){
				if(*(p + i) == '"') {
					*(p + i) = '\0';
					break;
				}
			}
			*(p+SESSION_BUFFER) = '\0';
			lstrcpyn(szSessionKey, p, SESSION_BUFFER);
		}
		free(szBuffer);
	}
	InternetCloseHandle(hRequest);
	
	if(lstrlen(szSessionKey) == 0){
		if(bAuthentication)	return 1;		// vF
		else				return 2;		// L[擾s
	}
	return 0;								// 擾
}


//---------------------------------------------------------------------------
// GetItemIndex() : j[ACẽCfbNX擾
//---------------------------------------------------------------------------
int GetItemIndex(UINT itemID)
{
	for(int i=0; i<pinfo.nBucketSize; i++){
		if(pinfo.nCommand[i] == itemID) return i;
	}
	
	return -1;
}


//---------------------------------------------------------------------------
// PostReclassify() : ̑M
//---------------------------------------------------------------------------
void PostReclassify(HINTERNET hSession, char *szSessionKey, DWORD nBucketIdx)
{
	HINTERNET	hRequest;
	std::string	szEntityBody;
	static const char	szHeader[] = "Content-Type: application/x-www-form-urlencoded";
	
	// M̐
	szEntityBody.append("session=");
	szEntityBody.append(szSessionKey);
	for(unsigned int i=0; i<mdata.size(); i++){
		szEntityBody.append("&rowid_");		szEntityBody.append(mdata[i].id);
		szEntityBody.append("=");			szEntityBody.append(mdata[i].id);
		szEntityBody.append("&reclassify_");szEntityBody.append(mdata[i].id);
		szEntityBody.append("=");			szEntityBody.append(pinfo.szPopfileBucket[nBucketIdx]);
	}
	szEntityBody.append("&change=go");
	
	// M
	hRequest = HttpOpenRequest(hSession, "POST", "/history", NULL, NULL, NULL, INTERNET_FLAG_EXISTING_CONNECT, 0);
	HttpSendRequest(hRequest, szHeader, sizeof(szHeader), (void*)szEntityBody.c_str(), szEntityBody.size());
	
	InternetCloseHandle(hRequest);
}


//---------------------------------------------------------------------------
// Reclassify() : 
//---------------------------------------------------------------------------
void Reclassify(DWORD nBucketIdx)
{
	HINTERNET	hInternet;
	HINTERNET	hSession;
	char		szSessionKey[SESSION_BUFFER] = "";
	char		szMessage[256];
	int			nResultCount[3] = { 0 };
	UINT		uType;
	
	// XṼoPceɕύX
	for(unsigned int i=0; i<mdata.size(); i++){
		lstrcpy(mdata[i].bucket, pinfo.szPopfileBucket[nBucketIdx]);
	}
	
	eda.DispMessageOnStatusBar("POPFile ɐڑ܂", -1);
	hInternet = InternetOpen("EdMax Plugin", INTERNET_OPEN_TYPE_DIRECT, NULL, NULL, 0);
	hSession  = InternetConnect(hInternet, "localhost", pinfo.nPopfilePort, NULL, NULL, INTERNET_SERVICE_HTTP, 0, 0);
	
	if(hSession != NULL){
		// ZbVL[擾
		eda.DispMessageOnStatusBar("ZbVL[擾", -1);
		switch(GetSessionKey(hSession, szSessionKey)){
			case 0:
				// 
				eda.DispMessageOnStatusBar("XV𑗐MĂ܂", -1);
				PostReclassify(hSession, szSessionKey, nBucketIdx);
				// XVmF
				eda.DispMessageOnStatusBar("XV̊mFc", -1);
				CheckReclassify();
				
				for(unsigned int i=0; i<mdata.size(); i++) nResultCount[mdata[i].state]++;
				
				for(int i=0; i<3; i++){
					uType = MB_OK;
					if(nResultCount[i] > 0){
						switch(i){
							case 0:
								wsprintf(szMessage, "%d̃bZ[Wĕނ܂", nResultCount[i]);
								break;
							case 1:
								wsprintf(szMessage, "%d̃bZ[W͍ĕނ܂ł", nResultCount[i]);
								uType |= MB_ICONWARNING;
								break;
							case 2:
								wsprintf(szMessage, "%d̃bZ[W͗̕ێԂ𒴉 \r\nĂ邽ߍĕނ܂ł", nResultCount[i]);
								uType |= MB_ICONWARNING;
								break;
						}
						MessageBox(NULL, szMessage, "POPfile ", uType);
					}
				}
				break;
			case 1:
				MessageBox(NULL, "pX[hF؂Ɏs܂", "POPfile ", MB_OK|MB_ICONWARNING);
				break;
			default:
				MessageBox(NULL, "ZbVL[̎擾Ɏs܂", "POPfile ", MB_OK|MB_ICONWARNING);
				break;
		}
		InternetCloseHandle(hSession);
	} else {
		MessageBox(NULL, "ڑɎs܂\r\nPOPFileNĂ邩mFĂ", "POPfile ", MB_OK|MB_ICONWARNING);
	}
	
	eda.DispMessageOnStatusBar("", -1);
	InternetCloseHandle(hInternet);
}


//---------------------------------------------------------------------------
// AppendMenuReclassify() : pj[ǉ
//---------------------------------------------------------------------------
void AppendMenuReclassify(HMENU hMenu)
{
	int		nPos;
	int		nMaildataSize;
	char	msg[_MAX_PATH + 1];
	char	szMenuItem[BUCKET_BUFFER + 4];
	HMENU	hSubMenu;
	
	int nSelCount = SendMessage(hWndList, LVM_GETSELECTEDCOUNT, 0, 0);
	
	// I64𒴉߂ꍇ͏Ȃ
	// ENbNɏdȂ肷̂
	if(nSelCount > 64) return;
	
	nPos = -1;
	mdata.clear();
	for(int i=0; i<nSelCount; i++){
		if((nPos = eda.GetNextMessagePath(nPos, msg, TRUE)) != -1){
			MAILDATA md = { "", "", "" };
			GetHeaderInfo(eda.GetMessage(msg), &md);
			eda.ReleaseEdmaxBuffer();
			if(lstrlen(md.id) > 0) mdata.push_back(md);
		}
	}
	
	//
	nMaildataSize = mdata.size();
	
	if(nMaildataSize == 1){
		// X-Text-Classification͏Ȃ̂, ̕ނ擾łȂ
		// IbZ[WЂƂ݂̂̏ꍇ, \ɕKvȂ̂Ńf[^x[X擾
		GetCurrentClassification();
	}
	
	if((nMaildataSize > 0)&&(pinfo.nBucketSize > 0)){
		hSubMenu = CreateMenu();
		for(int i=0; i<pinfo.nBucketSize; i++){
			pinfo.nCommand[i]	  = eda.GetTempID(hInstDll, CMD_RECLASSIFY + i);
			pinfo.nMenuChecked[i] = ((nMaildataSize == 1)&&(lstrcmp(pinfo.szPopfileBucket[i], mdata[0].bucket) == 0))? 1:0;
			// IbZ[W݂̌̕ނɁu*v\
			lstrcpy(szMenuItem, pinfo.szPopfileBucket[i]);
			if(pinfo.nMenuChecked[i]) strcat(szMenuItem, " *");
			
			AppendMenu(hSubMenu, MF_STRING, pinfo.nCommand[i], (LPCTSTR)szMenuItem);
		}
		AppendMenu(hMenu, MF_POPUP, (UINT)hSubMenu, "POPFile ");
	}
}


//---------------------------------------------------------------------------
// DllInit() : 
//---------------------------------------------------------------------------
int DllInit(void)
{
	HWND hTemp;
	char szPopfileUser[_MAX_PATH + 1];
	
	// EdMaxAPȈ
	if(eda.InitAPI() == FALSE) return 0;
	eda.GetStaticWindows(&hWndMain, &hTemp, &hWndList, &hTemp, &hTemp);
	
	// popfile.dboPcꗗ擾
	GetEnvironmentVariable("POPFILE_USER", szPopfileUser, _MAX_PATH);
	lstrcpy(pinfo.szPopfileDb, szPopfileUser);
	lstrcat(pinfo.szPopfileDb, "\\popfile.db");
	GetBuckets();
	
	// popfile.cfgRg[Z^[̃|[gԍ擾
	lstrcat(szPopfileUser, "\\popfile.cfg");
	wsprintf(pinfo.szPopfileUrl, "http://localhost:%d/", GetPortNumber(szPopfileUser));
	
	return 1;
}


//---------------------------------------------------------------------------
// EDH_OnHandleEvent() : Cxgnh
//---------------------------------------------------------------------------
#pragma argsused
DWORD EDH_OnHandleEvent(DWORD aindex, DWORD hID, WPARAM wParam, LPARAM lParam)
{
	DWORD dret = EVRNULL;
	
	switch(hID){
		// vOCvpeB
		case EV_REQUESTPROP:
			RequestProp((PLUGINPROP*)lParam);
			dret = EVROK;
			break;
		
		// j[ǉ
		case EV_MAKEMENU:
			switch(wParam){
				case MNT_MAILLIST:
					AppendMenuReclassify((HMENU)lParam);
					AppendMenu( (HMENU)lParam, MF_STRING, eda.GetTempID(hInstDll, CMD_OPENPOPFILE), "POPFile Rg[Z^[");
					dret = EVROK;
					break;
			}
			break;
	}
	
	return dret;
}


//---------------------------------------------------------------------------
// EDH_OnCmdProc() : R}hvV[W
//---------------------------------------------------------------------------
#pragma argsused
void EDH_OnCmdProc( DWORD aindex, DWORD nID, WPARAM wParam, LPARAM lParam)
{
	char szMessage[BUCKET_BUFFER + 32];
	
	switch(nID){
		// 
		case CMD_RECLASSIFY:
		case CMD_RECLASSIFY + 1:
		case CMD_RECLASSIFY + 2:
			if(eda.IsCommunicatingNow()){
				MessageBox(NULL, "ʐMɂ͒s܂", "POPFile ", MB_OK|MB_ICONWARNING);
				break;
			}
			if(pinfo.nMenuChecked[nID - CMD_RECLASSIFY]){
				wsprintf(szMessage, " %s ɕނĂ܂", pinfo.szPopfileBucket[nID - CMD_RECLASSIFY]);
				MessageBox(NULL, szMessage, "POPFile ", MB_OK|MB_ICONINFORMATION);
			} else {
				Reclassify(nID - CMD_RECLASSIFY);
			}
			break;
		
		// POPFile Rg[Z^[
		case CMD_OPENPOPFILE:
			ShellExecute(NULL, "open", pinfo.szPopfileUrl, NULL, NULL, SW_SHOWNORMAL);
			break;
	}
}


//---------------------------------------------------------------------------
// DllEntryPoint() : 
//---------------------------------------------------------------------------
bool WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
	switch(reason) 
	{
		case DLL_PROCESS_ATTACH:
			hInstDll = hinst;
			return DllInit();
	}
	return 1;
}


// \e
